
//
//  AoS.h - Array of Structures
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 13 Sep, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include "KariType.h"                                   // Master Definitions


#ifndef AoSAsm_H
#define AoSAsm_H

#ifdef __cplusplus
extern "C" {
#endif



typedef struct AoS_Type
{
    float x, y, z, w;
} AoS;




//
//  4096 Byte / 32 = 128byte blocks
//

#define SOA_ARY_MAX 8           // array of 8 in a structure (# of fields in an array)
#define SOA_BLK_MAX 32          // # structures in block

#define SOA_MAX     (SOA_ARY_MAX * SOA_BLK_MAX)



typedef struct {
    float x[SOA_ARY_MAX];
    float y[SOA_ARY_MAX];
    float z[SOA_ARY_MAX];
    float w[SOA_ARY_MAX];
} SoA8;


typedef struct SoABlk_Type
{
    SoA8 blk[SOA_BLK_MAX];      //  insert other data arrays
} SoABlk;





#ifdef __cplusplus
}
#endif

#endif  //AoSAsm_H





