        TITLE   FasX86.asm - 80(x)86 Math Addition & Subtraction
        PAGE    53,160

;  FasX86.asm - Math Addition & Subtraction
;
;  This document contains file that you may use at your own risk in your own programs.
;
;  This module is designed to accomodate the book.
;
;               This module is designed for fast 3D math
;
;  Created - 3 Oct 2001 - James Leiterman
;
;  Last Modification
;
;       Tabs = 8



        .XLIST

;;;        .387
;;;     .586P   .586    .686   .686P
;;;      .K3D    .XMM    .MMX

        .686
        .XMM

        .model flat, C


        include KariType.inc
        include vmp3DX86M.inc
 
        .LIST


        .data
        align   16


;------------------------------------------------------------------------------------------------


FasX86  SEGMENT USE32 PUBLIC 'CODE'

;-------------------------------------------------------------------------------------------------




;_________________________________________________________________________________________________
;=================================================================================================
;       (float) Addition
;
;void vmp_FAdd( float * const pfD, float fA, float fB )
;{
;       *pfD = A + B;
;}

;_________________________________________________________________________________________________

; *** 3DNow version ***
;
        align   16
        public  vmp_FAddAsm3DNow
vmp_FAddAsm3DNow       proc    near , pfD:ptr, fA:REAL4, fB:REAL4
        .K3D
;;;        femms

ASSERT_PTR(pfD)

        movd    mm0,fA                          ;       {0    Ax}
        movd    mm1,fB                          ;       {0    Bx}

        mov     eax,pfD                         ; Float Destination Pointer
        pfadd    mm0,mm1                                ;       {0    Ax+Bx}
        
        movd    [eax],mm0                       ;       A+B

;;;        femms
        ret
vmp_FAddAsm3DNow endp


;_________________________________________________________________________________________________


; *** SSE version ***
;
        align   16
        public  vmp_FAddAsmSSE
vmp_FAddAsmSSE       proc    near , pfD:ptr, fA:REAL4, fB:REAL4
        .XMM
;;;        emms

ASSERT_PTR(pfD)

        movss   xmm1,fB                         ;Bx       {0 0 0 Bx}
        movss   xmm0,fA                         ;Ax       {0 0 0 Ax}

        mov     eax,pfD                         ; Float Destination Pointer
        addss   xmm0,xmm1                       ;        {0 0 0 Ax+Bx}

        movss   [eax],xmm0                      ;        A+B    
        
;;;        emms
        ret
vmp_FAddAsmSSE endp



;_________________________________________________________________________________________________
;=================================================================================================
;       (float) Subtraction
;
;void vmp_FSub( float * const pfD, float fA, float fB )
;{
;       *pfD = A - B;
;}

;_________________________________________________________________________________________________

; *** 3DNow version ***
;
        align   16
        public  vmp_FSubAsm3DNow
vmp_FSubAsm3DNow       proc    near , pfD:ptr, fA:REAL4, fB:REAL4
        .K3D
;;;        femms

ASSERT_PTR(pfD)

        movd    mm0,fA                          ;       {0    Ax}
        movd    mm1,fB                          ;       {0    Bx}

        mov     eax,pfD                         ; Float Destination Pointer
        pfsub    mm0,mm1                                ;       {0    Ax-Bx}
        
        movd    [eax],mm0                       ;       A-B

;;;        femms
        ret
vmp_FSubAsm3DNow endp

;_________________________________________________________________________________________________



; *** SSE version ***
;
        align   16
        public  vmp_FSubAsmSSE
vmp_FSubAsmSSE       proc    near , pfD:ptr, fA:REAL4, fB:REAL4
        .XMM
;;;        emms

ASSERT_PTR(pfD)

        movss   xmm0,fA                         ;Ax       {0 0 0 Ax}
        movss   xmm1,fB                         ;Bx       {0 0 0 Bx}

        mov     eax,pfD                         ; Float Destination Pointer
        subss   xmm0,xmm1                       ;        {0 0 0 Ax-Bx}

        movss   [eax],xmm0                      ;        A-B    
        
;;;        emms
        ret
vmp_FSubAsmSSE endp






FasX86  ends
        end

