  
//
//  Vas3DEx.h - 3D Math Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"                                // Kari Games Master Definitions
#include    "CpuAsm.h"


#ifndef __Vas3DEx_H
#define __Vas3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vas3DSetup( const CpuInfo * const pcinfo );


void vmp_VecAddGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecAddAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecAddAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecAddAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);

void vmp_VecAddScalarGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecAddScalarAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecAddScalarAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecAddScalarAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);

void vmp_VecSubGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecSubAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecSubAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);
void vmp_VecSubAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB);

void vmp_VecSubScalarGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecSubScalarAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecSubScalarAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);
void vmp_VecSubScalarAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, float fScalar);





#ifdef __cplusplus
}
#endif

#endif  //__Vas3DEx_H


