  
//
//  FsfEx.h - (Scalar) Math Special Function (Float)
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#include    "CpuAsm.h"


#ifndef __FsfEx_H
#define __FsfEx_H

#ifdef __cplusplus
extern "C" {
#endif


void FsfSetup( const CpuInfo * const pcinfo );


void vmp_FSqrtGeneric(      float * const pfD, float fA );
void vmp_FSqrtAsm3DNow(     float * const pfD, float fA );
void vmp_FSqrtAsmSSE(       float * const pfD, float fA );

void vmp_FSqrtFastAsm3DNow( float * const pfD, float fA );
void vmp_FSqrtFastAsmSSE(   float * const pfD, float fA );
void vmp_FSqrtFastAsmSSE0(  float * const pfD, float fA );




#ifdef __cplusplus
}
#endif

#endif  //__FsfEx_H


