  
//
//  Vsf3DEx.h - 3D (Quad) Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include    "CpuAsm.h"



#ifndef __QVsf3DEx_H
#define __QVsf3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void QVsf3DSetup( const CpuInfo * const pcinfo );


void vmp_QVecSqrtGeneric(     vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecSqrtAsm3DNow(    vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecSqrtAsmSSE(      vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecSqrtAsmSSE0(     vmp3DQVector * const pvD, const vmp3DQVector * const pvA);

void vmp_QVecSqrtFastAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecSqrtFastAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecSqrtFastAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA);

void vmp_QVecMinGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMinAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMinAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMinAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );

void vmp_QVecMaxGeneric( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMaxAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMaxAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );
void vmp_QVecMaxAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB );

void vmp_QVecMagnitudeGeneric(     float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeAsm3DNow(    float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeAsmSSE(      float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeAsmSSE0(     float * const pfD, const vmp3DQVector * const pvA);

void vmp_QVecMagnitudeFastAsm3DNow(float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeFastAsmSSE(  float * const pfD, const vmp3DQVector * const pvA);
void vmp_QVecMagnitudeFastAsmSSE0( float * const pfD, const vmp3DQVector * const pvA);

void vmp_QVecNormalizeGeneric(     vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeAsm3DNow(    vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeAsmSSE(      vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeAsmSSE0(     vmp3DQVector * const pvD, const vmp3DQVector * const pvA);

void vmp_QVecNormalizeFastAsm3DNow(vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeFastAsmSSE(  vmp3DQVector * const pvD, const vmp3DQVector * const pvA);
void vmp_QVecNormalizeFastAsmSSE0( vmp3DQVector * const pvD, const vmp3DQVector * const pvA);


#ifdef __cplusplus
}
#endif

#endif  //__QVsf3DEx_H


