
//
//  VTrig3DX86.cpp - 3D Vector Trignometric Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <iostream.h>
#include    <math.h>

    //  Book Development Library Modules

#include    "vmp3D.h"
#include    "vmp3DEx.h"
#include    "VTrig3D.h"                                 // 3D Math
#include    "VTrig3DEx.h"



//
//  Setup Vec3D module
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void VTrig3DSetup( const CpuInfo * const pcinfo )
{
    if ( CPUBITS_3DNOW & pcinfo->nBits )
      {
        vmp_FSinCos =               vmp_FSinCosAsmFPU;
        vmp_FSin =                  vmp_FSinAsmFPU;
        vmp_FCos =                  vmp_FCosAsmFPU;
        vmp_FTan =                  vmp_FTanGeneric;

        vmp_FASin =                 vmp_FASinGeneric;
        vmp_FACos =                 vmp_FACosGeneric;
        vmp_FATan =                 vmp_FATanGeneric;
        vmp_FATan2 =                vmp_FATan2Generic;
      }
    
    else if ( CPUBITS_FPU & pcinfo->nBits )
      {
        vmp_FSinCos =               vmp_FSinCosAsmFPU;
        vmp_FSin =                  vmp_FSinAsmFPU;
        vmp_FCos =                  vmp_FCosAsmFPU;
        vmp_FTan =                  vmp_FTanGeneric;

        vmp_FASin =                 vmp_FASinGeneric;
        vmp_FACos =                 vmp_FACosGeneric;
        vmp_FATan =                 vmp_FATanGeneric;
        vmp_FATan2 =                vmp_FATan2Generic;
      }

    else
      {
        vmp_FSinCos =               vmp_FSinCosGeneric;
        vmp_FSin =                  vmp_FSinGeneric;
        vmp_FCos =                  vmp_FCosGeneric;
        vmp_FTan =                  vmp_FTanGeneric;

        vmp_FASin =                 vmp_FASinGeneric;
        vmp_FACos =                 vmp_FACosGeneric;
        vmp_FATan =                 vmp_FATanGeneric;
        vmp_FATan2 =                vmp_FATan2Generic;
      }
}


